/// <reference types="node" />
import React, { Component } from 'react';
import { EventEmitter } from 'events';
import { TooltipProps } from 'react-native-walkthrough-tooltip';
declare type OutcomeType = {
    event: string | symbol;
    action: (...args: any[]) => void;
};
export declare type ElementType = {
    id: string;
    content: TooltipProps['content'];
    placement?: TooltipProps['placement'];
    triggerEvent?: string | symbol;
    tooltipProps?: TooltipProps;
    onClose?: () => void;
    possibleOutcomes?: OutcomeType[];
};
export declare type GuideType = ElementType[];
export declare const nullElement: {
    id: string;
    content: undefined;
    placement: undefined;
};
export declare type ContextValue = {
    currentElement: ElementType;
    goToNext: () => void;
};
export declare const WalkthroughContext: React.Context<ContextValue>;
interface Props {
    eventEmitter: EventEmitter;
}
declare type State = {
    currentElement: ElementType;
    currentGuide: GuideType;
    currentPossibleOutcomes: OutcomeType[];
    outcomeListenerStartTimestamp?: number;
};
declare class ContextWrapper extends Component<Props, State> {
    constructor(props: Props);
    getCurrentElementIndex: () => number;
    clearGuide: () => void;
    clearCurrentPossibleOutcomes: () => void;
    addTimeoutCheckToOutcomeActions: ({ event, action: originalAction }: OutcomeType) => {
        event: string | symbol;
        action: () => void;
    };
    listenForPossibleOutcomes: (element: ElementType) => void;
    setElementNull: () => void;
    setElement: (element: ElementType) => void;
    setGuide: (guide: GuideType, callback?: (() => void) | undefined) => void;
    waitForTrigger: (element: ElementType, triggerEvent: string | symbol) => void;
    goToElement: (element: ElementType) => void;
    goToElementWithId: (id: string) => void;
    goToNext: () => void;
    render(): JSX.Element;
}
export default ContextWrapper;
